commit e9c3a7243bf7a4db9b0dec44d278e9bf527f3d9b
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Mon Oct 18 17:03:28 2021

    i386: Fix ICE in ix86_print_opreand_address [PR 102761]
    
    2021-10-18  Uroš Bizjak  <ubizjak@gmail.com>
    
            PR target/102761
    
    gcc/ChangeLog:
    
            * config/i386/i386.c (ix86_print_operand_address):
            Error out for non-address_operand asm operands.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/pr102761.c: New test.

diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index fa80daba523..42c47d2b12b 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -13767,7 +13767,10 @@ ix86_print_operand_address_as (FILE *file, rtx addr,
 static void
 ix86_print_operand_address (FILE *file, machine_mode /*mode*/, rtx addr)
 {
-  ix86_print_operand_address_as (file, addr, ADDR_SPACE_GENERIC, false);
+  if (this_is_asm_operands && ! address_operand (addr, VOIDmode))
+    output_operand_lossage ("invalid constraints for operand");
+  else
+    ix86_print_operand_address_as (file, addr, ADDR_SPACE_GENERIC, false);
 }
 
 /* Implementation of TARGET_ASM_OUTPUT_ADDR_CONST_EXTRA.  */
diff --git a/gcc/testsuite/gcc.target/i386/pr102761.c b/gcc/testsuite/gcc.target/i386/pr102761.c
new file mode 100644
index 00000000000..58ff27e4bcc
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102761.c
@@ -0,0 +1,11 @@
+/* PR target/102761 */
+/* { dg-do compile } */
+/* { dg-options "-O1" } */
+
+int foo (void);
+
+void
+bar (void)
+{
+  asm volatile ("%a0" : : "X"(foo () ? 2 : 1)); /* { dg-error "invalid constraints for operand" } */
+}

